<?php
/*------------------------------------------------------------------------
# productadvisor.php - Product advisor Component
# ------------------------------------------------------------------------
# author    Matthias Drobny, drobny.iT
# copyright Copyright (C) 2014. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   www.drobny.it
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Productadvisor component helper.
 */
abstract class ProductadvisorHelper
{
	/**
	 *	Configure the Linkbar.
	 */
	public static function addSubmenu($submenu) 
	{
		JSubMenuHelper::addEntry(JText::_('COM_PRODUCTADVISOR_PRODUCTS'), 'index.php?option=com_productadvisor&view=products', $submenu == 'products');
		JSubMenuHelper::addEntry(JText::_('COM_PRODUCTADVISOR_CATEGORIES'), 'index.php?option=com_categories&view=categories&extension=com_productadvisor', $submenu == 'categories');

		// set some global property
		$document = JFactory::getDocument();
		if ($submenu == 'categories'){
			$document->setTitle(JText::_('COM_PRODUCTADVISOR_CATEGORIES - Productadvisor'));
		};
	}

	/**
	 *	Get the actions
	 */
	public static function getActions($Id = 0)
	{
		jimport('joomla.access.access');

		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($Id)) {
			$assetName = 'com_productadvisor';
			$level = 'component';
		} else {
			$assetName = 'com_productadvisor.category.'.(int) $Id;
			$level = 'category';
		}

		$actions = JAccess::getActions('com_productadvisor', $level);
// print_r($actions);
		foreach ($actions as $action){
			$result->set($action->name, $user->authorise($action->name, $assetName));
		};

		return $result;
	}
}
?>