<?php
/*------------------------------------------------------------------------
# product.php - Product advisor Component
# ------------------------------------------------------------------------
# author    Matthias Drobny, drobny.iT
# copyright Copyright (C) 2014. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   www.drobny.it
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla modelform library
jimport('joomla.application.component.modeladmin');

class ProductadvisorModelProductattributes extends JModelAdmin
{
	/**
	 * Method override to check if you can edit an existing record.
	 *
	 * @param	array	$data	An array of input data.
	 * @param	string	$key	The name of the key for the primary key.
	 *
	 * @return	boolean
	 * @since	2.5
	 */
	protected function allowEdit($data = array(), $key = 'productattribute_id')
	{
		// Check specific edit permission then general edit permission.
		return JFactory::getUser()->authorise('core.edit', 'com_productadvisor.message.'. ((int) isset($data[$key]) ? $data[$key] : 0)) or parent::allowEdit($data, $key);
	}

	public function getTable($type = 'Productattributes', $prefix = 'ProductadvisorTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	public function getForm($data = array(), $loadData = true)
	{
		// Get the form.
		$form = $this->loadForm('com_productadvisor.Productattributes', 'Productattributes', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)){
			return false;
		};
		return $form;
	}

	public function save($data) {
		$return = TRUE;
		if(is_array($data['new_productattribute_catid'])) {
			foreach ($data['new_productattribute_catid'] as $key => $catid)
			{
				$data2 = array(
					'productattribute_id'	=>	0,
					'product_id'			=>	$data['product_id'],
					'attribute_catid'		=>	$catid,
					'attribute_value'		=>	$data['new_productattribute_value'][$key]
				);
				parent::save($data2);
			}
        }
        if(is_array($data['del_productattribute_id'])) {
			foreach ($data['del_productattribute_id'] as $key => $del)
			{
				if($del=='true') {
					$data2 = array(
						'productattribute_id'	=>	$key,
					);
					parent::delete($data2);
// 				} else {
// 					$data2 = array(
// 						'productattribute_id'	=>	$key,
// 						'product_id'			=>	$data['product_id'],
// 						'attribute_catid'		=>	$data['productattribute_catid'][$key],
// 						'attribute_value'		=>	$data['productattribute_value'][$key]
// 					);
// 					$return = ($return && parent::save($data2));
				}
			}
		}
		parent::save($data);
		return TRUE;
	}
	public function clearTable() {
		return $db = JFactory::getDBO()->truncateTable('#__productadvisor_productattributes');
	}
}
?>