<?php
/*------------------------------------------------------------------------
# products.php - Product advisor Component
# ------------------------------------------------------------------------
# author    Matthias Drobny, drobny.iT
# copyright Copyright (C) 2014. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   www.drobny.it
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
// import the Joomla modellist library
jimport('joomla.application.component.modellist');
/**
 * Products Model
 */
class ProductadvisorModelProducts extends JModelList
{
	/**
	 * Method to build an SQL query to load the list data.
	 *
	 * @return      string  An SQL query
	 */
	protected function getListQuery()
	{
		// Create a new query object.
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		// Select some fields
		$query->select('*');
// 		$query->select('pr.name as slug');
		// From the productadvisor_product table
		$query->from('#__productadvisor_products');

		return $query;
	}
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication();
		$session = JFactory::getSession();

		// Adjust the context to support modal layouts.
		if ($layout = JRequest::getVar('layout')) {
			$this->context .= '.'.$layout;
		}

		$attributes = ProductadvisorCategoryHelper::getAttributelist(FALSE);
		foreach($attributes as $a) {
			$a = (object) $a;
// 			$attr = $this->getUserStateFromRequest($this->context.'.filter.'.$a->alias, 'filter_'.$a->alias, '', 'string');
// 			$this->setState('filter.'.$a->alias, $attr);	
			$attr = $this->getUserStateFromRequest($this->context.'.filter.'.$a->id, 'filter_'.$a->id, '', 'string');
			$this->setState('filter.'.$a->id, $attr);	
		}
	}
	
	public function getItems() {
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);

		// jimport('joomla.application.component.helper');
		$params = JComponentHelper::getParams('com_productadvisor');
		foreach(explode(",", $params->get('COM_PRODUCTADVISOR_CATEGORIES_INT_VALUES')) as $v) {
			$attrTypes[$v] = 'int';
		}
		foreach(explode(",", $params->get('COM_PRODUCTADVISOR_CATEGORIES_TEXT_VALUES')) as $v) {
			$attrTypes[$v] = 'text';
		}

		$attrTypes = $this->getAttrTypes();
		$attributes = ProductadvisorCategoryHelper::getAttributelist(FALSE);

		$where = array();
		foreach($attributes as $a) {
			$value = $this->getState('filter.'.$a['id']);
			if(!empty($value)) {
// 				echo JDatabase::quote($value);
// 				mysql_real_escape_string()
				if(in_array(substr($value, 0, 1), array("<", ">"))) {
					$operator = substr($value, 0, 1);
					$value = substr($value, 1);
				} else {
					$operator = "=";
				}
 				$where[] = '(pa.attribute_catid = "'.$a['id'].'" AND pa.attribute_value '.$operator.' '.$db->quote(($value)).')';
			}
			if(!isset($attrTypes[$a['id']])) $attrTypes[$a['id']] = 'text';
		}
// 		$sqlSelect = array(" ");
// print_r($_REQUEST);
		foreach($attributes as $a) {
// 			$value = $this->getState('filter.'.$a['alias']);
			$value = $this->getState('filter.'.$a['id']);
// print_r($a);
			if(!empty($value)) {
				if(in_array(substr($value, 0, 1), array("<", ">"))) {
					$operator = substr($value, 0, 1)."=";
					$value = substr($value, 1);
				} else {
					$operator = "=";
				}
$operator = ">=";
				switch($attrTypes[$a['id']]) {
					case "text":
						$sqlSelect[]	= "(1-ABS(STRCMP(pa_".$a['id'].".attribute_value, ".$db->quote($value).")/2))";
					break;
					case "int":
						switch($operator) {
							case "<=":
							case ">=":
							case "<":
							case ">":
								$sqlSelect[]	= "IF(
									pa_".$a['id'].".attribute_value ".$operator." ".$value.", 
									1, 
									((pa_".$a['id'].".attribute_value)/".$value.")
								)";
							break;
							case "=":
								$sqlSelect[]	= "(1-(GREATEST(pa_".$a['id'].".attribute_value, ".$db->quote($value).") - LEAST(pa_".$a['id'].".attribute_value, ".$db->quote($value)."))/GREATEST(pa_".$a['id'].".attribute_value, ".$db->quote($value)."))";
							break;
						}
					break;
				}
			} else {
				$sqlSelect[]	= "1";
			}

			$sqlJoin[]		= "LEFT JOIN #__productadvisor_productattributes AS pa_".$a['id']." ON p.product_id = pa_".$a['id'].".product_id AND pa_".$a['id'].".attribute_catid = ".$a['id'];
		}
		$params = JComponentHelper::getParams('com_productadvisor');
// 		$params->get('COM_PRODUCTADVISOR_FILTER_THRESHOLD', 0.8);

		$sqlSelect = count($sqlSelect)>0 ? ", ".implode("*", $sqlSelect)." AS rating" : "";
		$sql = "
			SELECT * ". $sqlSelect."
			FROM #__productadvisor_products AS p
		".implode(" ", $sqlJoin)."
			HAVING rating >= ".$params->get('COM_PRODUCTADVISOR_FILTER_THRESHOLD', 0.8)."
			ORDER BY ".$params->get('COM_PRODUCTADVISOR_PRODUCTS_ORDERING', 'rating DESC')."
			LIMIT 0,".$params->get('COM_PRODUCTADVISOR_FILTER_LIMIT', 10)."
		";
// echo $sql;
$db->setQuery("SET SQL_BIG_SELECTS=1");
$db->query();
echo $sql;

		$db->setQuery($sql);
// LEFT JOIN #__productadvisor_productattributes AS pa_114 ON p.product_id = pa_114.product_id AND pa_114.attribute_catid = 114 
// LEFT JOIN #__productadvisor_productattributes AS pa_115 ON p.product_id = pa_115.product_id AND pa_115.attribute_catid = 115 

// echo __FILE__;
// echo $sql;
// print_r($db->loadObject());
// $db->loadObjectList();
// print_r($db->getErrorMsg());
		return $db->loadObjectList();
	}
	
	private function getAttrTypes() {
		$params = JComponentHelper::getParams('com_productadvisor');
		foreach(explode(",", $params->get('COM_PRODUCTADVISOR_CATEGORIES_INT_VALUES')) as $v) {
			$attrTypes[$v] = 'int';
		}
		foreach(explode(",", $params->get('COM_PRODUCTADVISOR_CATEGORIES_TEXT_VALUES')) as $v) {
			$attrTypes[$v] = 'text';
		}
		return $attrTypes;
	}
	
	/**
	*	@toDo
	*/
	private function getAttrUnits() {
	
	}

}
?>